IF EXISTS (SELECT * FROM SYS.VIEWS
					 WHERE
						OBJECT_ID = OBJECT_ID(N'[DBO].[V_BC_LANC_FLUXO_CAIXA]'))
	DROP VIEW [DBO].[V_BC_LANC_FLUXO_CAIXA]

GO
--SELECT * FROM V_BC_LANC_FLUXO_CAIXA WHERE cd_bc_lanc=616618
--SELECT * FROM BC_CONTAS
CREATE VIEW [dbo].[V_BC_LANC_FLUXO_CAIXA] AS
SELECT     
	BC_CONTAS_PRC_GRP_ECON.CD_GRP_ECON,
	BC_LANC.CD_EMP,
	BC_LANC.CD_BC_LANC,
	BC_LANC.CD_CNT, 
	PG_TP_FORN.DS_TP, 
	BC_LANC.DT_LANCTO, 
	BC_LANC.VLR_LANC, 
	BC_CONTAS.FLAG_FLUXO, 
	PG_TP_FORN.CD_TP_FORN,
	BC_LANC.TP_LANC,
	'CREDITOS DIRETO BANCARIO' AS ORIGEM,
	RC_TP_LANC.STS_LANC
FROM         
	BC_LANC INNER JOIN RC_TP_LANC ON 
	BC_LANC.CD_EMP = RC_TP_LANC.CD_EMP AND 
	BC_LANC.CD_TP_LANC = RC_TP_LANC.CD_TP_LANC 
	INNER JOIN PG_TP_FORN ON 
	RC_TP_LANC.CD_EMP = PG_TP_FORN.CD_EMP AND 
	RC_TP_LANC.CD_CLASS_FLUXO_CX = PG_TP_FORN.CD_TP_FORN 
	INNER JOIN RC_RECTA_RAT_BC_LANC ON 
	BC_LANC.CD_EMP = RC_RECTA_RAT_BC_LANC.CD_EMP AND 
	BC_LANC.CD_BC_LANC = RC_RECTA_RAT_BC_LANC.CD_BC_LANC 
    INNER JOIN BC_CONTAS ON 
    BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND 
    BC_LANC.CD_CNT = BC_CONTAS.CD_CNT
    INNER JOIN BC_CONTAS_PRC_GRP_ECON ON
    BC_CONTAS.CD_EMP = BC_CONTAS_PRC_GRP_ECON.CD_EMP AND
    BC_CONTAS.CD_CNT = BC_CONTAS_PRC_GRP_ECON.CD_CNT 
UNION ALL
SELECT     
	BC_CONTAS_PRC_GRP_ECON.CD_GRP_ECON,
	BC_LANC.CD_EMP,
	BC_LANC.CD_BC_LANC, 
	BC_LANC.CD_CNT,
	PG_TP_FORN.DS_TP, 
	BC_LANC.DT_LANCTO, 
	BC_LANC.VLR_LANC, 
	BC_CONTAS.FLAG_FLUXO, 
	PG_TP_FORN.CD_TP_FORN,
	BC_LANC.TP_LANC,
	'DEBITOS DIRETO BANCARIO' AS ORIGEM,
	RC_TP_LANC.STS_LANC
FROM         
	BC_LANC INNER JOIN RC_TP_LANC ON 
	BC_LANC.CD_EMP = RC_TP_LANC.CD_EMP AND 
	BC_LANC.CD_TP_LANC = RC_TP_LANC.CD_TP_LANC 
	INNER JOIN PG_TP_FORN ON 
	RC_TP_LANC.CD_EMP = PG_TP_FORN.CD_EMP AND 
	RC_TP_LANC.CD_CLASS_FLUXO_CX = PG_TP_FORN.CD_TP_FORN 
	INNER JOIN BC_CONTAS ON 
	BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND 
	BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND 
	BC_LANC.CD_CNT = BC_CONTAS.CD_CNT AND 
    BC_LANC.CD_CNT = BC_CONTAS.CD_CNT 
    INNER JOIN PG_DESP_RAT_BC_LANC ON 
    BC_LANC.CD_EMP = PG_DESP_RAT_BC_LANC.CD_EMP AND 
    BC_LANC.CD_BC_LANC = PG_DESP_RAT_BC_LANC.CD_BC_LANC
	INNER JOIN BC_CONTAS_PRC_GRP_ECON ON
    BC_CONTAS.CD_EMP = BC_CONTAS_PRC_GRP_ECON.CD_EMP AND
    BC_CONTAS.CD_CNT = BC_CONTAS_PRC_GRP_ECON.CD_CNT 
UNION ALL
SELECT     
	BC_CONTAS_PRC_GRP_ECON.CD_GRP_ECON,
	BC_LANC.CD_EMP,
	BC_LANC.CD_BC_LANC, 
	BC_LANC.CD_CNT,
	'CONTA DESTINO ' + ' - ' + BC_CONTAS_1.NR_CNT + ' - ' + BC_CONTAS_1.AGC_CNT AS DS_TP, 
	BC_LANC.DT_LANCTO, 
	BC_LANC.VLR_LANC, 
	BC_CONTAS.FLAG_FLUXO, 
	PG_TP_FORN.CD_TP_FORN,
	BC_LANC.TP_LANC,
	'TRANSFERENCIA CONTAS DEBITO' AS ORIGEM,
	RC_TP_LANC.STS_LANC
FROM         
	BC_LANC INNER JOIN RC_TP_LANC ON 
	BC_LANC.CD_EMP = RC_TP_LANC.CD_EMP AND 
	BC_LANC.CD_TP_LANC = RC_TP_LANC.CD_TP_LANC 
	INNER JOIN PG_TP_FORN ON 
	RC_TP_LANC.CD_EMP = PG_TP_FORN.CD_EMP AND 
	RC_TP_LANC.CD_CLASS_FLUXO_CX = PG_TP_FORN.CD_TP_FORN 
	INNER JOIN BC_CONTAS ON 
	BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND 
    BC_LANC.CD_CNT = BC_CONTAS.CD_CNT 
    INNER JOIN BC_LANC_TRANSF ON 
    BC_LANC.CD_EMP = BC_LANC_TRANSF.CD_EMP AND 
    BC_LANC.CD_BC_LANC = BC_LANC_TRANSF.CD_BC_LANC_ORIG    
    INNER JOIN BC_CONTAS AS BC_CONTAS_1 ON
    BC_LANC_TRANSF.CD_EMP = BC_CONTAS_1.CD_EMP AND
	BC_LANC_TRANSF.CD_CNT_DEST = BC_CONTAS_1.CD_CNT 
	INNER JOIN BC_CONTAS_PRC_GRP_ECON ON
    BC_CONTAS.CD_EMP = BC_CONTAS_PRC_GRP_ECON.CD_EMP AND
    BC_CONTAS.CD_CNT = BC_CONTAS_PRC_GRP_ECON.CD_CNT 
    LEFT OUTER JOIN CHQ_LANC_CPL_TRANSF ON
    BC_LANC.CD_EMP = CHQ_LANC_CPL_TRANSF.CD_EMP AND 
    BC_LANC.CD_BC_LANC = CHQ_LANC_CPL_TRANSF.CD_BC_LANC_ORIG
WHERE
	CHQ_LANC_CPL_TRANSF.CD_BC_LANC_ORIG IS NULL	  
UNION ALL
SELECT     
	BC_CONTAS_PRC_GRP_ECON.CD_GRP_ECON,
	BC_LANC.CD_EMP,
	BC_LANC.CD_BC_LANC, 
	BC_LANC.CD_CNT,
	'CONTA ORIGEM ' + ' - ' + BC_CONTAS_1.NR_CNT + ' - ' + BC_CONTAS_1.AGC_CNT AS DS_TP, 
	BC_LANC.DT_LANCTO, 
	BC_LANC.VLR_LANC, 
	BC_CONTAS.FLAG_FLUXO, 
	PG_TP_FORN.CD_TP_FORN,
	BC_LANC.TP_LANC,
	'TRANSFERENCIA CONTAS CREDITO' AS ORIGEM,
	RC_TP_LANC.STS_LANC
FROM         
	BC_LANC INNER JOIN RC_TP_LANC ON 
	BC_LANC.CD_EMP = RC_TP_LANC.CD_EMP AND 
	BC_LANC.CD_TP_LANC = RC_TP_LANC.CD_TP_LANC 
	INNER JOIN PG_TP_FORN ON 
	RC_TP_LANC.CD_EMP = PG_TP_FORN.CD_EMP AND 
	RC_TP_LANC.CD_CLASS_FLUXO_CX = PG_TP_FORN.CD_TP_FORN 
	INNER JOIN BC_CONTAS ON 
	BC_LANC.CD_EMP = BC_CONTAS.CD_EMP AND 
	BC_LANC.CD_CNT = BC_CONTAS.CD_CNT  
    INNER JOIN BC_LANC_TRANSF ON 
    BC_LANC.CD_EMP = BC_LANC_TRANSF.CD_EMP AND 
    BC_LANC.CD_BC_LANC = BC_LANC_TRANSF.CD_BC_LANC_DEST
    INNER JOIN BC_CONTAS AS BC_CONTAS_1 ON
    BC_LANC_TRANSF.CD_EMP = BC_CONTAS_1.CD_EMP AND
	BC_LANC_TRANSF.CD_CNT_ORIG = BC_CONTAS_1.CD_CNT
	INNER JOIN BC_CONTAS_PRC_GRP_ECON ON
    BC_CONTAS.CD_EMP = BC_CONTAS_PRC_GRP_ECON.CD_EMP AND
    BC_CONTAS.CD_CNT = BC_CONTAS_PRC_GRP_ECON.CD_CNT 
    LEFT OUTER JOIN CHQ_LANC_CPL_TRANSF ON
    BC_LANC.CD_EMP = CHQ_LANC_CPL_TRANSF.CD_EMP AND 
    BC_LANC.CD_BC_LANC = CHQ_LANC_CPL_TRANSF.CD_BC_LANC_DEST
WHERE
	CHQ_LANC_CPL_TRANSF.CD_BC_LANC_DEST IS NULL