IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLES
			 WHERE TABLE_NAME='CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC')
begin
CREATE TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC](
	[CD_CTR_GRUPO] [int] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_MC] [int] NOT NULL,
	[CD_USU] [int] NOT NULL,
	[DT_CAD] [datetime] NOT NULL,
	[QT_IT] [money] NOT NULL,
	[PERC_DESC] [money] NOT NULL,
	[VLR_IT] [money] NOT NULL,
 CONSTRAINT [PK_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] PRIMARY KEY CLUSTERED 
(
	[CD_CTR_GRUPO] ASC,
	[CD_EMP] ASC,
	[CD_MC] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] ADD  CONSTRAINT [DF_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_CD_USU]  DEFAULT ((0)) FOR [CD_USU]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] ADD  CONSTRAINT [DF_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_QT_IT]  DEFAULT ((0)) FOR [QT_IT]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] ADD  CONSTRAINT [DF_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_PERC_DESC]  DEFAULT ((0)) FOR [PERC_DESC]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] ADD  CONSTRAINT [DF_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_VLR_IT]  DEFAULT ((0)) FOR [VLR_IT]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC]  WITH CHECK ADD  CONSTRAINT [FK_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_CG_FND_VERBA_NOTA_CREDITO_GRUPO] FOREIGN KEY([CD_CTR_GRUPO])
REFERENCES [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO] ([CD_CTR_GRUPO])

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] CHECK CONSTRAINT [FK_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_CG_FND_VERBA_NOTA_CREDITO_GRUPO]

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC]  WITH CHECK ADD  CONSTRAINT [FK_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_EST_MC] FOREIGN KEY([CD_EMP], [CD_MC])
REFERENCES [dbo].[EST_MC] ([CD_EMP], [CD_MC])

ALTER TABLE [dbo].[CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC] CHECK CONSTRAINT [FK_CG_FND_VERBA_NOTA_CREDITO_GRUPO_EST_MC_EST_MC]
END