/****** Object:  Trigger [TRG_EST_PROD_CPL_MEDIAF_AUDIT]    Script Date: 07/01/2013 15:57:33 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[TRG_EST_PROD_CPL_MEDIAF_AUDIT]'))
DROP TRIGGER [dbo].[TRG_EST_PROD_CPL_MEDIAF_AUDIT]
GO
GO
CREATE TRIGGER [dbo].[TRG_EST_PROD_CPL_MEDIAF_AUDIT] ON [dbo].[EST_PROD_CPL_MEDIAF] 
FOR UPDATE,DELETE
AS	 
IF CONTEXT_INFO() = 0x66666 
	RETURN

IF UPDATE(QTDE_FINANCIADO) 
OR UPDATE(QTDE_FACEAMENTO) 
OR UPDATE(QTDE_LIMITADOR) 
OR UPDATE(QTDE_MEDIAF)
OR UPDATE(CD_SIGLA)
BEGIN
	-- SE FOR UPDATE
	IF EXISTS (SELECT TOP 1 CD_EMP FROM INSERTED )
		BEGIN
			INSERT INTO EST_PROD_CPL_MEDIAF_AUDIT
			(   CD_EMP, CD_FILIAL, CD_PROD, CD_SIGLA,  CD_SIGLA_ANT, QTDE_MEDIAF, QTDE_MEDIAF_ANT, 			
				QTDE_FINANCIADO, QTDE_FINANCIADO_ANT, QTDE_FACEAMENTO, QTDE_FACEAMENTO_ANT, QTDE_LIMITADOR,
				QTDE_LIMITADOR_ANT, VALID_QTDE_FACEAMENTO, 	VALID_QTDE_FACEAMENTO_ANT, QT_VD_ATUAL, 
				QT_VD_ATUAL_ANT, QT_VD_MES1, QT_VD_MES1_ANT, QT_VD_MES2, QT_VD_MES2_ANT, QT_VD_MES3,
				QT_VD_MES3_ANT, LIMITP, LIMITP_ANT, LIMITV, LIMITV_ANT, CD_USU, CD_USU_ANT, DT_CAD, 
				DT_CAD_ANT, DT_ULT_ALT, DT_ULT_ALT_ANT, SAZ, SAZ_ANT, DT_NASC, DT_NASC_ANT, 
				MEDIAF_TRANSF,MEDIAF_TRANSF_ANT,DT_CAD_AUDIT)
			SELECT     
				D.CD_EMP, 
				D.CD_FILIAL, 
				D.CD_PROD, 			
				I.CD_SIGLA, 
				D.CD_SIGLA,			
				I.QTDE_MEDIAF, 
				D.QTDE_MEDIAF, 			
				I.QTDE_FINANCIADO, 
				D.QTDE_FINANCIADO, 			
				I.QTDE_FACEAMENTO, 
				D.QTDE_FACEAMENTO, 			
				I.QTDE_LIMITADOR, 
				D.QTDE_LIMITADOR, 			
				I.VALID_QTDE_FACEAMENTO, 
				D.VALID_QTDE_FACEAMENTO, 			
				I.QT_VD_ATUAL, 
				D.QT_VD_ATUAL, 			
				I.QT_VD_MES1, 
				D.QT_VD_MES1,			 
				I.QT_VD_MES2, 
				D.QT_VD_MES2,			
				I.QT_VD_MES3, 
				D.QT_VD_MES3,			
				I.LIMITP, 
				D.LIMITP, 			
				I.LIMITV, 
				D.LIMITV, 			
				I.CD_USU, 
				D.CD_USU, 			
				I.DT_CAD, 
				D.DT_CAD, 			
				I.DT_ULT_ALT, 
				D.DT_ULT_ALT, 			
				I.SAZ, 
				D.SAZ, 			
				I.DT_NASC, 
				D.DT_NASC, 			
				I.MEDIAF_TRANSF,
				D.MEDIAF_TRANSF,			
				GETDATE()
			FROM         
				DELETED D 
				INNER JOIN INSERTED I ON 
				D.CD_EMP = I.CD_EMP AND
				D.CD_FILIAL = I.CD_FILIAL AND
				D.CD_PROD = I.CD_PROD
		END
	ELSE
		BEGIN
			INSERT INTO EST_PROD_CPL_MEDIAF_AUDIT
			(   CD_EMP, CD_FILIAL, CD_PROD, CD_SIGLA,  CD_SIGLA_ANT, QTDE_MEDIAF, QTDE_MEDIAF_ANT, 			
				QTDE_FINANCIADO, QTDE_FINANCIADO_ANT, QTDE_FACEAMENTO, QTDE_FACEAMENTO_ANT, QTDE_LIMITADOR,
				QTDE_LIMITADOR_ANT, VALID_QTDE_FACEAMENTO, 	VALID_QTDE_FACEAMENTO_ANT, QT_VD_ATUAL, 
				QT_VD_ATUAL_ANT, QT_VD_MES1, QT_VD_MES1_ANT, QT_VD_MES2, QT_VD_MES2_ANT, QT_VD_MES3,
				QT_VD_MES3_ANT, LIMITP, LIMITP_ANT, LIMITV, LIMITV_ANT, CD_USU, CD_USU_ANT, DT_CAD, 
				DT_CAD_ANT, DT_ULT_ALT, DT_ULT_ALT_ANT, SAZ, SAZ_ANT, DT_NASC, DT_NASC_ANT, 
				MEDIAF_TRANSF,MEDIAF_TRANSF_ANT,DT_CAD_AUDIT)
			SELECT     
				D.CD_EMP, 
				D.CD_FILIAL, 
				D.CD_PROD, 			
				0, 
				D.CD_SIGLA,			
				0, 
				D.QTDE_MEDIAF, 			
				0, 
				D.QTDE_FINANCIADO, 			
				0, 
				D.QTDE_FACEAMENTO, 			
				0, 
				D.QTDE_LIMITADOR, 			
				NULL, 
				D.VALID_QTDE_FACEAMENTO, 			
				0, 
				D.QT_VD_ATUAL, 			
				0, 
				D.QT_VD_MES1,			 
				0, 
				D.QT_VD_MES2,			
				0, 
				D.QT_VD_MES3,			
				0, 
				D.LIMITP, 			
				0, 
				D.LIMITV, 			
				0, 
				D.CD_USU, 			
				NULL, 
				D.DT_CAD, 			
				NULL, 
				D.DT_ULT_ALT, 			
				0, 
				D.SAZ, 			
				NULL, 
				D.DT_NASC, 			
				0,
				D.MEDIAF_TRANSF,			
				GETDATE()
			FROM         
				DELETED D 
		END
END
