IF EXISTS
(
    SELECT 1
    FROM SYS.VIEWS
    WHERE NAME = 'V_EST_PROD_CPL_DEMANDA_PROC_CPL'
)
    BEGIN
        DROP VIEW V_EST_PROD_CPL_DEMANDA_PROC_CPL;
    END;
GO
--SELECT * FROM V_EST_PROD_CPL_DEMANDA_PROC_CPL WHERE CD_CTR_DEMANDA_PROC = 10
CREATE VIEW V_EST_PROD_CPL_DEMANDA_PROC_CPL AS
SELECT        
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR_DEMANDA_PROC, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_FILIAL, 
    EST_PROD_CPL_DEMANDA_PROC_CPL.CD_PROD, 
	EST_PROD.DS_PROD, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QTDE_DEMANDA, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QT_VD_ATUAL, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QT_VD_MES1, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QT_VD_MES2, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QT_VD_MES3, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.LIMITP, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.LIMITV, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.SAZ, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.DT_NASC, 
    EST_PROD_CPL_DEMANDA_PROC_CPL.STS_PROD, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.TP_NIVEL_PERC, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.PERC_VARIACAO, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.DS_PERC_VARIACAO, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.QTDE_DEMANDA_ANTERIOR, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_SIGLA, 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_SIGLA_ANTERIOR, 
	ISNULL(EST_PROD_CPL_DEMANDA_PROC_CPL_LIB.CD_USU,0) AS CD_USU_LIB, 
	ISNULL(LIB.NM_USU,'') AS NM_USU_LIB,		
	EST_PROD_CPL_DEMANDA_PROC_CPL_LIB.DT_CAD AS DT_LIB, 
    EST_PROD_CPL_DEMANDA_PROC_CPL_LIB_PENDENTE.DT_CAD AS DT_LIB_PENDENTE, 
	EST_PROD_CPL_DEMANDA_PROC_CPL_PENDENTE_APLICAR_MEDIAF.DT_CAD AS DT_APLICAR_PENDENTE, 
	ISNULL(EST_PROD_CPL_DEMANDA_PROC_CPL_BLOQUEIO.CD_USU,0) AS CD_USU_BLQ, 
	ISNULL(BLQ.NM_USU,'') AS NM_USU_BLQ,		
	EST_PROD_CPL_DEMANDA_PROC_CPL_BLOQUEIO.DT_CAD AS DT_BLOQUEIO
FROM            
	EST_PROD_CPL_DEMANDA_PROC_CPL LEFT OUTER JOIN EST_PROD_CPL_DEMANDA_PROC_CPL_LIB ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR = EST_PROD_CPL_DEMANDA_PROC_CPL_LIB.CD_CTR_PROC_CPL 
	LEFT OUTER JOIN GLB_USU LIB ON
	EST_PROD_CPL_DEMANDA_PROC_CPL_LIB.CD_USU = LIB.CD_USU
	LEFT OUTER JOIN EST_PROD_CPL_DEMANDA_PROC_CPL_BLOQUEIO ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR = EST_PROD_CPL_DEMANDA_PROC_CPL_BLOQUEIO.CD_CTR_PROC_CPL 
	LEFT OUTER JOIN GLB_USU BLQ ON
	EST_PROD_CPL_DEMANDA_PROC_CPL_LIB.CD_USU = BLQ.CD_USU
	LEFT OUTER JOIN EST_PROD_CPL_DEMANDA_PROC_CPL_LIB_PENDENTE ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR = EST_PROD_CPL_DEMANDA_PROC_CPL_LIB_PENDENTE.CD_CTR_PROC_CPL 
	LEFT OUTER JOIN EST_PROD_CPL_DEMANDA_PROC_CPL_PENDENTE_APLICAR_MEDIAF ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_CTR = EST_PROD_CPL_DEMANDA_PROC_CPL_PENDENTE_APLICAR_MEDIAF.CD_CTR_PROC_CPL 
	INNER JOIN EST_PROD ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_EMP = EST_PROD.CD_EMP AND 
	EST_PROD_CPL_DEMANDA_PROC_CPL.CD_PROD = EST_PROD.CD_PROD
UNION ALL
SELECT        
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_CTR, 
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_CTR_DEMANDA_PROC, 
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_FILIAL, 
    EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_PROD, 
	EST_PROD.DS_PROD, 
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.QTDE_DEMANDA, 
	0 AS QT_VD_ATUAL, 
	0 AS QT_VD_MES1, 
	0 AS QT_VD_MES2, 
	0 AS QT_VD_MES3, 
	0 AS LIMITP, 
	0 AS LIMITV, 
	0 AS SAZ, 
	NULL AS DT_NASC, 
    EST_PROD.STS_PROD, 
	TIPO_NAO_PROCESSAR AS TP_NIVEL_PERC, 
	0 AS PERC_VARIACAO, 
	'HISTORICO NAO PROCESSAR' AS DS_PERC_VARIACAO, 
	0 AS QTDE_DEMANDA_ANTERIOR, 
	0 AS CD_SIGLA, 
	0 AS CD_SIGLA_ANTERIOR, 
	0 AS CD_USU_LIB, 
	'NAO DEFINIDO' AS NM_USU_LIB,		
	NULL AS DT_LIB, 
    NULL AS DT_LIB_PENDENTE, 
	NULL AS DT_APLICAR_PENDENTE, 
	0 AS CD_USU_BLQ, 
	'' AS NM_USU_BLQ,		
	NULL AS DT_BLOQUEIO
FROM            
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR 
	LEFT OUTER JOIN EST_PROD ON 
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_EMP = EST_PROD.CD_EMP AND 
	EST_PROD_CPL_DEMANDA_PROC_CPL_NAO_PROCESSAR.CD_PROD = EST_PROD.CD_PROD