/****** Object:  View [dbo].[V_EST_PROD_TRANSF_FASES_FATURAMENTO]    Script Date: 07/04/2013 16:59:30 ******/
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[V_EST_PROD_TRANSF_FASES_FATURAMENTO]'))
DROP VIEW [dbo].[V_EST_PROD_TRANSF_FASES_FATURAMENTO]
GO
GO
GO
GO
--SELECT * FROM V_EST_PROD_TRANSF_FASES_FATURAMENTO WHERE DT_TRANSF='2019-01-05'
CREATE VIEW V_EST_PROD_TRANSF_FASES_FATURAMENTO AS
SELECT
	EST_PROD_TRANSF.CD_EMP,
	EST_PROD_TRANSF.CD_FILIAL,
	EST_PROD_TRANSF.CD_FIL_DEST,
	EST_PROD_TRANSF.CD_CTR AS CODIGO_RESSUPRIMENTO,
	ISNULL(EST_PROD_TRANSF_PED_VD.CD_PED,0) AS CODIGO_PRE_FATURA,
	EST_PROD_TRANSF.DT_TRANSF,
	CONVERT(CHAR(16),EST_PROD_TRANSF.HR_TRANSF,120) AS HORA_RESSUPRIMENTO,
	CONVERT(CHAR(10),EST_PROD_TRANSF_CONF.DT_CONF,120) + ' ' +
	CONVERT(CHAR(5),EST_PROD_TRANSF_CONF.HR_FIM,114) AS HORA_CHECKOUT,
	DATEDIFF(HOUR,CONVERT(CHAR(16),EST_PROD_TRANSF.HR_TRANSF,120),CONVERT(CHAR(10),EST_PROD_TRANSF_CONF.DT_CONF,120) + ' ' +
	CONVERT(CHAR(5),EST_PROD_TRANSF_CONF.HR_FIM,114)) AS DIF_RES_CHECKOUT_HORAS,
	EST_PED_VD.CD_PED AS PRE_FATURA,
	CONVERT(CHAR(16),EST_PED_VD.DT_GRAVACAO,120) AS HORA_PREFATURA,
	DATEDIFF(MINUTE,CONVERT(CHAR(10),EST_PROD_TRANSF_CONF.DT_CONF,120) + ' ' +
	CONVERT(CHAR(5),EST_PROD_TRANSF_CONF.HR_FIM,114),
	CONVERT(CHAR(16),EST_PED_VD.DT_GRAVACAO,120)) AS DIF_CHECKOUT_PRE_MINUTOS,
	EST_NF_SAI.NF_NF AS NUMERO_NOTA,
	CONVERT(CHAR(10),EST_NF_SAI.DT_EMI_NF,120) + ' ' +
	CONVERT(CHAR(5),EST_NF_SAI.HR_EMI_NF,114) AS HORA_NOTA_FISCAL_SAIDA,
	DATEDIFF(MINUTE,CONVERT(CHAR(16),EST_PED_VD.DT_GRAVACAO,120),
	CONVERT(CHAR(10),EST_NF_SAI.DT_EMI_NF,120) + ' ' +
	CONVERT(CHAR(5),EST_NF_SAI.HR_EMI_NF,114)) AS DIF_PRE_NOTA_FISCAL_MINUTOS,
	CONVERT(CHAR(16),DT_RECBTO,120) AS DATA_VALIDACAO_SEFAZ,
	DATEDIFF(MINUTE,CONVERT(CHAR(10),EST_NF_SAI.DT_EMI_NF,120) + ' ' +
	CONVERT(CHAR(5),EST_NF_SAI.HR_EMI_NF,114),CONVERT(CHAR(16),DT_RECBTO,120)) AS DIF_NOTA_FISCAL_VALIDACAO_SEFAZ_MINUTOS,

	CONVERT(CHAR(16),EST_NF_SAI_CHECKIN_ENTRADA.DT_CAD,120) AS HORA_DATA_CHECKIN_DESTINO,
	CONVERT(CHAR(10),EST_NF_ENT.DT_ENT,120) + ' ' +
	CONVERT(CHAR(5),EST_NF_ENT.HR_ENT,114) AS HORA_NOTA_FISCAL_ENTRADA_DESTINO,
	CASE WHEN EST_PROD_TRANSF.STS_TRANSF =0 THEN
		'PENDENTE'
	WHEN EST_PROD_TRANSF.STS_TRANSF =1 THEN
		'PRE-FATURA'
	WHEN EST_PROD_TRANSF.STS_TRANSF =2 THEN
		'FATURADO'
	WHEN EST_PROD_TRANSF.STS_TRANSF =3 THEN
		'CHECKOUT'
	WHEN EST_PROD_TRANSF.STS_TRANSF =4 THEN
		'CANCELADO'
	WHEN EST_PROD_TRANSF.STS_TRANSF =5 THEN
		'CHECKOUT INICIADO'
	WHEN EST_PROD_TRANSF.STS_TRANSF =6 THEN
		'SALDO PENDENTE'
	ELSE
		'NAO DEFINIDO'
	END AS STS_TRANSF
FROM
	EST_PROD_TRANSF LEFT OUTER JOIN EST_PROD_TRANSF_PED_VD ON
	EST_PROD_TRANSF.CD_EMP = EST_PROD_TRANSF_PED_VD.CD_EMP AND
	EST_PROD_TRANSF.CD_FILIAL = EST_PROD_TRANSF_PED_VD.CD_FILIAL AND
	EST_PROD_TRANSF.CD_CTR = EST_PROD_TRANSF_PED_VD.CD_CTR
	LEFT OUTER JOIN EST_PROD_TRANSF_CONF_FASES ON
	EST_PROD_TRANSF.CD_EMP = EST_PROD_TRANSF_CONF_FASES.CD_EMP AND
	EST_PROD_TRANSF.CD_FILIAL = EST_PROD_TRANSF_CONF_FASES.CD_FILIAL AND
	EST_PROD_TRANSF.CD_CTR = EST_PROD_TRANSF_CONF_FASES.CD_CTR

	LEFT OUTER JOIN EST_PROD_TRANSF_CONF ON
	EST_PROD_TRANSF_CONF_FASES.CD_EMP = EST_PROD_TRANSF_CONF.CD_EMP AND
	EST_PROD_TRANSF_CONF_FASES.CD_CONTROLE = EST_PROD_TRANSF_CONF.CD_CONTROLE AND
	EST_PROD_TRANSF_CONF_FASES.CD_CTR_FASES = EST_PROD_TRANSF_CONF.CD_CTR_FASES  

	LEFT OUTER JOIN EST_PED_VD ON
	EST_PROD_TRANSF_PED_VD.CD_EMP = EST_PED_VD.CD_EMP AND
	EST_PROD_TRANSF_PED_VD.CD_FILIAL = EST_PED_VD.CD_FILIAL AND
	EST_PROD_TRANSF_PED_VD.CD_PED = EST_PED_VD.CD_PED 
	LEFT OUTER JOIN EST_NF_SAI_PED_VD ON
	EST_PED_VD.CD_EMP = EST_NF_SAI_PED_VD.CD_EMP AND
	EST_PED_VD.CD_FILIAL = EST_NF_SAI_PED_VD.CD_FILIAL AND
	EST_PED_VD.CD_PED = EST_NF_SAI_PED_VD.CD_PED 
	LEFT OUTER JOIN EST_NF_SAI ON
	EST_NF_SAI_PED_VD.CD_EMP = EST_NF_SAI.CD_EMP AND
	EST_NF_SAI_PED_VD.CD_FILIAL = EST_NF_SAI.CD_FILIAL AND
	EST_NF_SAI_PED_VD.CD_NF = EST_NF_SAI.CD_NF 
	LEFT OUTER JOIN EST_NF_SAI_NFE ON
	EST_NF_SAI_PED_VD.CD_EMP = EST_NF_SAI_NFE.CD_EMP AND
	EST_NF_SAI_PED_VD.CD_FILIAL = EST_NF_SAI_NFE.CD_FILIAL AND
	EST_NF_SAI_PED_VD.CD_NF = EST_NF_SAI_NFE.CD_NF 
	LEFT OUTER JOIN EST_NF_SAI_CHECKIN_ENTRADA ON
	EST_NF_SAI.CD_EMP = EST_NF_SAI_CHECKIN_ENTRADA.CD_EMP AND
	EST_NF_SAI.CD_FILIAL = EST_NF_SAI_CHECKIN_ENTRADA.CD_FILIAL AND
	EST_NF_SAI.CD_NF = EST_NF_SAI_CHECKIN_ENTRADA.CD_NF 
	LEFT OUTER JOIN EST_NF_ENT_EST_NF_SAI_TRANSF ON
	EST_NF_SAI.CD_EMP = EST_NF_ENT_EST_NF_SAI_TRANSF.CD_EMP AND
	EST_NF_SAI.CD_FILIAL = EST_NF_ENT_EST_NF_SAI_TRANSF.CD_FIL_ORIG AND
	EST_NF_SAI.CD_NF=EST_NF_ENT_EST_NF_SAI_TRANSF.CD_NF_SAI
	LEFT OUTER JOIN EST_NF_ENT ON
	EST_NF_ENT_EST_NF_SAI_TRANSF.CD_EMP = EST_NF_ENT.CD_EMP AND
	EST_NF_ENT_EST_NF_SAI_TRANSF.CD_FIL_DEST = EST_NF_ENT.CD_FILIAL AND
	EST_NF_ENT_EST_NF_SAI_TRANSF.CD_NF_ENT=EST_NF_ENT.CD_NF
