IF NOT EXISTS(
	SELECT 
		1
	FROM 
		 sys.tables 
	WHERE 
		NAME = 'EST_PROD_TBL_DESC' )
BEGIN
CREATE TABLE [dbo].[EST_PROD_TBL_DESC](
	[CD_EMP] [int] NOT NULL,
	[CD_TBL_DESC] [int] NOT NULL,
	[DS_TBL_DESC] [nvarchar](100) NOT NULL,
	[DT_INI] [datetime] NOT NULL,
	[DT_FIM] [datetime] NOT NULL,
	[DT_FIM_ORIG] [datetime] NOT NULL,
	[ST_PRORROG] [int] NULL,
	[CD_TP_DESCONTO] [int] NOT NULL,
	[CD_USU] [int] NOT NULL,
	[DT_CAD] [datetime] NOT NULL,
	[DT_ULT_ALT] [datetime] NULL,
	[STS_TBL_DESC] [int] NULL,
	[FLAG_DESC_FIX] [int] NULL,
	[FLAG_DESC_RECEITA] [int] NULL,
 CONSTRAINT [PK_EST_PROD_TBL_DESC] PRIMARY KEY CLUSTERED 
(
	[CD_EMP] ASC,
	[CD_TBL_DESC] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]



ALTER TABLE [dbo].[EST_PROD_TBL_DESC]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_TBL_DESC_GLB_TP_DESCONTO] FOREIGN KEY([CD_TP_DESCONTO])
REFERENCES [dbo].[GLB_TP_DESCONTO] ([CD_TP_DESCONTO])
ON UPDATE CASCADE


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] CHECK CONSTRAINT [FK_EST_PROD_TBL_DESC_GLB_TP_DESCONTO]


ALTER TABLE [dbo].[EST_PROD_TBL_DESC]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_TBL_DESC_GLB_USU] FOREIGN KEY([CD_USU])
REFERENCES [dbo].[GLB_USU] ([CD_USU])
ON UPDATE CASCADE


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] CHECK CONSTRAINT [FK_EST_PROD_TBL_DESC_GLB_USU]


ALTER TABLE [dbo].[EST_PROD_TBL_DESC]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_TBL_DESC_PRC_EMP] FOREIGN KEY([CD_EMP])
REFERENCES [dbo].[PRC_EMP] ([CD_EMP])


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] CHECK CONSTRAINT [FK_EST_PROD_TBL_DESC_PRC_EMP]


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] ADD  CONSTRAINT [DF_EST_PROD_TBL_DESC_ST_PRORROG]  DEFAULT ((0)) FOR [ST_PRORROG]

ALTER TABLE [dbo].[EST_PROD_TBL_DESC] ADD  CONSTRAINT [DF_EST_PROD_TBL_DESC_CD_TP_DESCONTO]  DEFAULT ((0)) FOR [CD_TP_DESCONTO]


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] ADD  DEFAULT ((0)) FOR [FLAG_DESC_FIX]


ALTER TABLE [dbo].[EST_PROD_TBL_DESC] ADD  DEFAULT ((0)) FOR [FLAG_DESC_RECEITA]


END