IF EXISTS
(
    SELECT *
    FROM SYS.VIEWS
    WHERE OBJECT_ID = OBJECT_ID(N'[DBO].[V_PDV_VD_NFCE]')
)
    DROP VIEW [dbo].[V_PDV_VD_NFCE];
GO

--SELECT TOP 1 * FROM PDV_VD
--SELECT TOP 1 PIS_COFINS,* FROM PDV_VD_IT

/*SP_HELP V_PDV_VD_NFCE --- 
SELECT TOP 1 * FROM PDV_VD_IT  
SELECT * FROM V_PDV_VD_NFCE where cd_emp = 1 and cd_filial = 43 and CD_VD = 3*/

CREATE VIEW [dbo].[V_PDV_VD_NFCE]
AS
     SELECT PDV_VD.CD_EMP
          , PDV_VD.CD_FILIAL
          , PDV_VD.CD_VD
          , PDV_VD.CD_CX
          , PDV_VD.CD_CLI
          , ISNULL(V_GLB_PESSOA.RAZAO_SOCIAL_PESSOA, '') AS NM_DEST
          , ISNULL(V_GLB_PESSOA.NOME_FANTASIA_PESSOA, '') AS NM_FANT
          , ISNULL(V_GLB_PESSOA.CGC_CPF, '') AS CGC_CPF
          , ISNULL(V_GLB_PESSOA.INSC_EST, '') AS INSC_EST
          , ISNULL(V_GLB_PESSOA.INSC_MUNI, '') AS INSC_MUNI
          , ISNULL(V_GLB_PESSOA.ENDERECO_PESSOA, '') AS ENDE
          , ISNULL(V_GLB_PESSOA.NUMERO_ENDERECO_PESSOA, '') AS NUMERO
          , ISNULL(V_GLB_PESSOA.BAIRRO_ENDERECO_PESSOA, '') AS BAIRRO
          , ISNULL(V_GLB_PESSOA.CEP_ENDERECO_PESSOA, '') AS CEP
          , ISNULL(V_GLB_PESSOA.TELEFONE_PESSOA, '') AS TEL
          , ISNULL(V_GLB_PESSOA.DS_CID, '') AS DS_CID
          , ISNULL(V_GLB_PESSOA.UF, '') AS UF
          , ISNULL(V_GLB_PESSOA.CD_CID, 0) AS CD_CID
          , ISNULL(V_GLB_PESSOA.COD_IBGE_MUNICIPIO, 0) AS COD_IBGE
          , ISNULL(V_GLB_PESSOA.CONTRIBUINTE, 0) AS CONTRIBUINTE
          , PDV_VD.NR_ECF
          , I.CD_VEND
          , PDV_VD.DT_VD
          , PDV_VD.HR_VD
          , PDV_VD.VLR_VD -- SELECT TOP 1 * FROM PDV_vD
          , PDV_VD.VLR_LIQ_VD
          , PDV_VD.VLR_DINH
          , PDV_VD.VLR_CARTAO
          , PDV_VD.VLR_TICKETS
          , PDV_VD.VLR_CONV
          , PDV_VD.VLR_TOT_PROD
          , V_PDV_VD_CAB.VLR_BASE_ICMS
          , V_PDV_VD_CAB.VLR_ICMS
          , 0 AS VLR_ISENTAS
          , 0 AS VLR_SUBST_TRIB
          , 0 AS VLR_N_INCIDENCIA
          , ISNULL(V_PDV_VD_CAB.VLR_ISSQN, 0) AS VLR_ISSQN 
          , 0 AS VLR_FRETE
          , 0 AS VLR_OUTRAS_DESP
          , (V_PDV_VD_CAB.VLR_DESC + PDV_VD.VLR_DESC_ITENS) AS VLR_DESC_CORPO
          , PDV_VD.ST_VD
          , I.CD_PROD
          , EST_PROD.DS_PROD
          , I.VLR_IT
         -- , ROUND(I.QT_IT * I.VLR_IT * I.TX_DESC / 100, 2) AS VLR_DESC_IT
	   --no calcular pela taxa, pois quando a terceira casa decimal  5 no PDV trunca e no 
	   --Gestao ao fazer a conta arredonda isso causa diferena de 1 centavo 
	   --Exemplo:
	   --PDV: 29,94 * 25% = 7,485  que fica 7,48
	   --GESTAO: 29,94 * 25% = 7,485 que fica 7,49
	   
	     ,(I.VLR_IT * I.QT_IT) - (I.TOT_IT - I.VLR_DESC_TOT_RAT ) AS VLR_DESC_IT
          , I.QT_IT
          , I.TOT_IT		
		, (I.TOT_IT - I.VLR_DESC_TOT_RAT ) AS VLR_IT_LIQ
		,I.VLR_DESC_TOT_RAT
          , CASE
                WHEN RIGHT(I.CD_TRIB_FC, 2) IN('00', '20')
            AND ISNULL(I.TIPO_IMPOSTO, 0) = 0
            AND I.TP_PROD <> 10
            AND I.ST_IT = 1
                THEN(I.TOT_IT - I.VLR_DESC_TOT_RAT)
                ELSE 0
            END AS VLR_BASE_ICMS_IT
          , I.TX_ICMS_IT AS ALIQ_ICMS
          , CASE
                WHEN RIGHT(I.CD_TRIB_FC, 2) IN('00', '20')
     AND ISNULL(I.TIPO_IMPOSTO, 0) = 0
     AND I.TP_PROD <> 10
     AND I.ST_IT = 1
                THEN(I.TOT_IT - I.VLR_DESC_TOT_RAT) * (I.TX_ICMS_IT / 100)
                ELSE 0
            END AS VLR_ICMS_IT
          , I.VLR_CUSTO  
          , 0 AS VLR_BASE_SUBS_IT
	    
          ,CASE WHEN RIGHT(I.CD_TRIB_FC, 2) = '40' THEN
		I.TOT_IT - I.VLR_DESC_TOT_RAT
	   ELSE

 	  0 END AS VLR_ISENTO_IT
          , CASE
                WHEN RIGHT(I.CD_TRIB_FC, 2) = '40'
                THEN 1
                ELSE 0
            END AS ISENTO
          , CASE
                WHEN RIGHT(I.CD_TRIB_FC, 2) IN('00', '20')
AND ISNULL(I.TIPO_IMPOSTO, 0) = 0
AND I.TP_PROD <> 10
AND I.ST_IT = 1
                THEN 1
                ELSE 0
            END AS ICMS
	 
          , 0 AS VLR_N_INCIDENCIA_IT
	
		   , CASE WHEN FL.REGIME_TRIBUTARIO = 1 OR FL.REGIME_TRIBUTARIO = 2 THEN 
				CASE WHEN I.CD_TRIB_FC = '500' THEN 
				   '5.405' 
				ELSE 
				   '5.102' 
				END 
			 ELSE 
			   (CASE 
				   WHEN I.TIPO_IMPOSTO = 0 
				   THEN CASE 
						  WHEN RIGHT(I.CD_TRIB_FC, 2) = '10' 
							  OR RIGHT(I.CD_TRIB_FC, 2) = '60' 
							 OR RIGHT(I.CD_TRIB_FC, 2) = '70' 
						  THEN '5.405' 
						  ELSE '5.102' 
					   END 
				   ELSE '5.933' 
				END) 
			 END AS CFOP 

          , I.CD_TRIB_FC AS CD_TRIB
          , PDV_VD.DT_CAD
          , PDV_VD.CD_USU_OPE AS CD_USU
          , 0 AS DEST_ORIG
          , I.CD_IT
          , I.ST_IT
          , I.PIS_COFINS
          , L.DS_SIGLA_LINHA
          , I.TX_DESC AS PERC_DESC_IT
          , EST_PROD.NR_NCM
          , I.LISTA_PROD
          , EST_PROD_UN_MED.DS_UN AS UN
          , ISNULL(CL.CD_FILIAL, 0) AS CD_FILIAL_CLI
          , EST_PROD.CTR_LOTE
          , ISNULL(EST_PROD.CONTROLE_SNGPC, 0) AS CONTROLE_SNGPC
          , ISNULL(I.VLR_BASE_PIS, 0) AS VLR_BASE_PIS_IT
          , ISNULL(I.VLR_PIS, 0) AS VLR_PIS_IT
          , ISNULL(I.VLR_BASE_COFINS, 0) AS VLR_BASE_COFINS_IT
          , ISNULL(I.VLR_COFINS, 0) AS VLR_COFINS_IT
          , CASE
                WHEN RIGHT(I.CD_TRIB_FC, 2) IN('00', '20')
AND ISNULL(I.TIPO_IMPOSTO, 0) = 1
AND I.TP_PROD = 10
AND I.ST_IT = 1
                THEN(I.TOT_IT - I.VLR_DESC_TOT_RAT) * (I.TX_ICMS_IT / 100)
                ELSE 0
            END AS VLR_ISSQN_IT
          , CASE
                WHEN ISNULL(I.TIPO_IMPOSTO, 0) = 1
                     AND I.TP_PROD = 10
                THEN I.TX_ICMS_IT
                ELSE 0
            END AS PERC_ISSQN
          , ISNULL(I.PERC_ALIQ_COFINS, 0) AS PERC_ALIQ_COFINS
          , ISNULL(I.PERC_ALIQ_PIS, 0) AS PERC_ALIQ_PIS
          , V_GLB_PESSOA.ENVIAR_XML_NFE
          , V_GLB_PESSOA.EMAIL_PESSOA AS EMAIL
          , ISNULL(I.CST_PIS, 0) AS CST_PIS
          , ISNULL(I.CST_COFINS, 0) AS CST_COFINS
          , (CASE
                 WHEN RIGHT(I.CD_TRIB_FC, 2) = '40'
                 THEN(I.TOT_IT - I.VLR_DESC_TOT_RAT)
                 ELSE 0
             END) AS VLR_ISENTAS_IT
          , ISNULL(I.PIS_COFINS_RECALCULADO, 0) AS PIS_COFINS_RECALCULADO
          , ISNULL(I.TIPO_TRIBUTACAO_PIS_COFINS, 0) AS TIPO_TRIBUTACAO_PIS_COFINS
          , FL.FLAG_OPERADOR_LOG
          , EST_PROD.CTR_PMC
          , NFE.CH_NFE    AS NR_AUTORIZADOR
          , NFE.NR_PROT   AS NR_PROTOCOLO 
          , NFE.DT_RECBTO
          , NFE.DIG_VAL   AS DG_VALIDADOR
          , NFE.VER_APLIC AS VS_APLIC
          , ISNULL(I.VLR_PMC, 0)   AS VLR_PMC
          , FL.CD_FILIAL_CONTAB
          , FLAG_NFE = 1
          , V_PDV_VD_CAB.QTDE_ITENS
          , NFE.SERIE
          , GLB_CID.UF AS UF_FILIAL
          , ISNULL(FL.REGIME_TRIBUTARIO, 0) REGIME_TRIBUTARIO
		,ISNULL(PDV_VD.NR_MFE,0)NR_MFE
		,ISNULL(PDV_VD_NFCE_CANCEL.TP_EMIS,0)INUTILIZADO
		,V_GLB_PESSOA.CONSUMIDOR_FINAL
     FROM
          PDV_VD
          INNER JOIN PDV_VD_IT I
          ON PDV_VD.CD_EMP = I.CD_EMP
             AND PDV_VD.CD_FILIAL = I.CD_FILIAL
             AND PDV_VD.CD_VD = I.CD_VD
             AND PDV_VD.DT_VD = I.DT_VD
          INNER JOIN EST_PROD
          ON I.CD_EMP = EST_PROD.CD_EMP
             AND I.CD_PROD = EST_PROD.CD_PROD
          INNER JOIN V_PDV_VD_CAB
          ON PDV_VD.CD_EMP = V_PDV_VD_CAB.CD_EMP
             AND PDV_VD.CD_FILIAL = V_PDV_VD_CAB.CD_FILIAL
             AND PDV_VD.CD_VD = V_PDV_VD_CAB.CD_VD
             AND PDV_VD.DT_VD = V_PDV_VD_CAB.DT_VD
          --INNER JOIN PDV_VD_PDV_VD_NFCE
          --ON PDV_VD.CD_EMP = PDV_VD_PDV_VD_NFCE.CD_EMP
          --   AND PDV_VD.CD_FILIAL = PDV_VD_PDV_VD_NFCE.CD_FILIAL
          --   AND PDV_VD.CD_VD = PDV_VD_PDV_VD_NFCE.CD_VD
          --INNER JOIN PDV_VD_NFCE
          --ON PDV_VD_PDV_VD_NFCE.CD_EMP = PDV_VD_NFCE.CD_EMP
          --   AND PDV_VD_PDV_VD_NFCE.CD_FILIAL = PDV_VD_NFCE.CD_FILIAL
          --   AND PDV_VD_PDV_VD_NFCE.CD_NFCE = PDV_VD_NFCE.CD_NFCE
          INNER JOIN EST_PROD_UN_MED
          ON EST_PROD.CD_EMP = EST_PROD_UN_MED.CD_EMP
             AND EST_PROD.CD_UN_VD = EST_PROD_UN_MED.CD_CTR_UN
          INNER JOIN PRC_FILIAL FL
          ON PDV_VD.CD_EMP = FL.CD_EMP
             AND PDV_VD.CD_FILIAL = FL.CD_FILIAL
          INNER JOIN EST_PROD_EST_ARV_MERCADOLOGICA AS ARV
          ON EST_PROD.CD_EMP = ARV.CD_EMP
             AND EST_PROD.CD_PROD = ARV.CD_PROD
          INNER JOIN EST_ARV_MERC_LINHA AS L
          ON ARV.CD_EMP = L.CD_EMP
             AND ARV.CD_ARV_MERC_LINHA = L.CD_ARV_MERC_LINHA
          LEFT JOIN GLB_CID
          ON FL.CD_CID = GLB_CID.CD_CID
          OUTER APPLY
          UFD_GLB_PESSOA(PDV_VD.CD_CLI, 0) V_GLB_PESSOA LEFT OUTER JOIN PRC_FILIAL_RC_CLI AS CL
                                                        ON PDV_VD.CD_EMP = CL.CD_EMP
                                                           AND PDV_VD.CD_CLI = CL.CD_CLI
                                                           AND PDV_VD.CD_FILIAL = CL.CD_FILIAL


	 OUTER APPLY	
				(SELECT TOP 1   
					PDV_VD_NFCE.CH_NFE
						 , PDV_VD_NFCE.NR_PROT  
					 , PDV_VD_NFCE.DT_RECBTO
					 , PDV_VD_NFCE.DIG_VAL  
					 , PDV_VD_NFCE.VER_APLIC,
	  
					PDV_VD_NFCE.SERIE,
					PDV_VD_NFCE.CD_NFCE  
					FROM PDV_VD_NFCE  
					join  PDV_VD_PDV_VD_NFCE on   
					PDV_VD_PDV_VD_NFCE.CD_EMP = PDV_VD_NFCE.CD_EMP  
					AND PDV_VD_PDV_VD_NFCE.CD_FILIAL = PDV_VD_NFCE.CD_FILIAL  
					AND PDV_VD_PDV_VD_NFCE.CD_NFCE = PDV_VD_NFCE.CD_NFCE
			 
     WHERE  
     PDV_VD.CD_EMP = PDV_VD_PDV_VD_NFCE.CD_EMP  
     AND PDV_VD.CD_FILIAL = PDV_VD_PDV_VD_NFCE.CD_FILIAL  
     AND PDV_VD.CD_VD		= PDV_VD_PDV_VD_NFCE.CD_VD ) NFE 
	
	LEFT JOIN PDV_VD_NFCE_CANCEL ON 
	NFE.CD_NFCE    = PDV_VD_NFCE_CANCEL.CD_NFCE 

     WHERE I.CD_EMP = 1
	and ISNULL(PDV_VD.FLAG_NFCE,0) = 1
	--AND PDV_VD.nr_ecf = 4655 and PDV_VD.cd_filial = 20 and PDV_VD.dt_vd = '20180607'


	