IF EXISTS (SELECT 	 *
					 FROM
						 sys.views
					 WHERE
						object_id = OBJECT_ID(N'[dbo].[V_EST_NF_SAI_CONTABIL]'))
	DROP VIEW [dbo].[V_EST_NF_SAI_CONTABIL]

GO

--select * from V_EST_NF_SAI_CONTABIL where cd_emp = 1 and dt_cad between '2012-02-02' and '2012-02-02' AND CD_FILIAL = 4 AND NF_NF = 4339
CREATE VIEW [dbo].[V_EST_NF_SAI_CONTABIL]
AS
	--versao 2467
SELECT
		V_EST_NF_SAI_CAB.CD_EMP
		,V_EST_NF_SAI_CAB.CD_FILIAL
		,V_EST_NF_SAI_CAB.DT_CAD
		,V_EST_NF_SAI_CAB.DT_EMI_NF
		,V_EST_NF_SAI_CAB.CD_CLI                         AS CD_DEST
		,V_EST_NF_SAI_CAB.NM_DEST
		,''                                              AS HIST
		,VLR_NF
		,V_EST_NF_SAI_CAB.NF_NF
		,-- select top 10 * from V_EST_NF_SAI_CAB
		NM_FANT
		,V_EST_NF_SAI_CAB.VLR_ICMS                       VLR_ICMS_ITENS
		,V_EST_NF_SAI_CAB.VLR_ICMS_SUBS_CAB              AS VLR_ICMS_SUBS_ITENS
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.BASE_COFINS_NF AS VLR_BASE_PIS_COFINS
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.PIS_NF         AS VLR_PIS
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.COFINS_NF      AS VLR_COFINS
		,V_EST_NF_SAI_CAB.TP_MOV
		,DS_MOV_OP                                       AS TP_MOV_DS
		,CASE WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 1 THEN ISNULL((SELECT
																												CD_CTB_CNT
																											FROM
																												PG_FORN_CNT_CTB
																											WHERE
																											 PG_FORN_CNT_CTB.CD_EMP  = V_EST_NF_SAI_CAB.CD_EMP AND
																											 PG_FORN_CNT_CTB.CD_FORN = V_EST_NF_SAI_CAB.CD_CLI), '')
		 WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 2 THEN ISNULL((SELECT
																												CD_CTB_CNT
																											FROM
																												PRC_FILIAL_CNT_CTB
																											WHERE
																											 PRC_FILIAL_CNT_CTB.CD_EMP     = V_EST_NF_SAI_CAB.CD_EMP AND
																											 PRC_FILIAL_CNT_CTB.CD_FILIAL  = V_EST_NF_SAI_CAB.CD_CLI AND
																											 PRC_FILIAL_CNT_CTB.TP_CNT_CTB = 42), '')
		 WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 0 THEN ISNULL((SELECT
																												CD_CTB_CNT
																											FROM
																												RC_CLI_CNT_CTB
																											WHERE
																											 RC_CLI_CNT_CTB.CD_EMP     = V_EST_NF_SAI_CAB.CD_EMP AND
																											 RC_CLI_CNT_CTB.CD_CLI     = V_EST_NF_SAI_CAB.CD_CLI AND
																											 RC_CLI_CNT_CTB.TP_CNT_CTB = 0), '')
		 ELSE ''
		 END                                             AS CD_CTB_CNT
		,CASE WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 1 THEN ISNULL((SELECT
																												CD_CTB_CNT_RED
																											FROM
																												PG_FORN_CNT_CTB
																											WHERE
																											 PG_FORN_CNT_CTB.CD_EMP  = V_EST_NF_SAI_CAB.CD_EMP AND
																											 PG_FORN_CNT_CTB.CD_FORN = V_EST_NF_SAI_CAB.CD_CLI), 0)
		 WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 2 THEN ISNULL((SELECT
																												CD_CTB_CNT_RED
																											FROM
																												PRC_FILIAL_CNT_CTB
																											WHERE
																											 PRC_FILIAL_CNT_CTB.CD_EMP     = V_EST_NF_SAI_CAB.CD_EMP AND
																											 PRC_FILIAL_CNT_CTB.CD_FILIAL  = V_EST_NF_SAI_CAB.CD_CLI AND
																											 PRC_FILIAL_CNT_CTB.TP_CNT_CTB = 42), 0)
		 WHEN V_EST_NF_SAI_CAB.DEST_ORIG = 0 THEN ISNULL((SELECT
																												CD_CTB_CNT_RED
																											FROM
																												RC_CLI_CNT_CTB
																											WHERE
																											 RC_CLI_CNT_CTB.CD_EMP     = V_EST_NF_SAI_CAB.CD_EMP AND
																											 RC_CLI_CNT_CTB.CD_CLI     = V_EST_NF_SAI_CAB.CD_CLI AND
																											 RC_CLI_CNT_CTB.TP_CNT_CTB = 0), 0)
		 ELSE '0'
		 END                                             AS CD_CTB_CNT_RED
		,V_EST_NF_SAI_CAB.DEST_ORIG
		,V_EST_NF_SAI_CAB.CD_NT_MOV                      AS CD_MOV_OP
		,V_EST_NF_SAI_CAB.STS_NF
	FROM
		V_EST_NF_SAI_CAB
		LEFT OUTER JOIN PDV_VD_EST_NF_SAI ON
			V_EST_NF_SAI_CAB.CD_EMP = PDV_VD_EST_NF_SAI.CD_EMP AND
			V_EST_NF_SAI_CAB.CD_FILIAL = PDV_VD_EST_NF_SAI.CD_FILIAL AND
			V_EST_NF_SAI_CAB.CD_NF = PDV_VD_EST_NF_SAI.CD_NF
		LEFT JOIN V_EST_NF_SAI_IMPOSTOS_PIS_COFINS ON
			V_EST_NF_SAI_CAB.CD_EMP = V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.CD_EMP AND
			V_EST_NF_SAI_CAB.CD_FILIAL = V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.CD_FILIAL AND
			V_EST_NF_SAI_CAB.CD_NF = V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.CD_NF
	WHERE
		PDV_VD_EST_NF_SAI.CD_NF IS NULL AND
		V_EST_NF_SAI_CAB.TP_MOV <> 28
		AND ISNULL(FLAG_N_EXPORTAR_CONTABIL,0) = 0
	GROUP  BY
		V_EST_NF_SAI_CAB.CD_FILIAL
		,V_EST_NF_SAI_CAB.DT_CAD
		,V_EST_NF_SAI_CAB.DT_EMI_NF
		,V_EST_NF_SAI_CAB.CD_CLI
		,V_EST_NF_SAI_CAB.NM_DEST
		,V_EST_NF_SAI_CAB.VLR_ICMS
		,V_EST_NF_SAI_CAB.TP_MOV
		,DS_MOV_OP
		,V_EST_NF_SAI_CAB.DS_MOV_OP
		,V_EST_NF_SAI_CAB.DEST_ORIG
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.BASE_COFINS_NF
		,V_EST_NF_SAI_CAB.NF_NF
		,NM_FANT
		,V_EST_NF_SAI_CAB.VLR_NF
		,V_EST_NF_SAI_CAB.CD_EMP
		,V_EST_NF_SAI_CAB.DEST_ORIG
		,V_EST_NF_SAI_CAB.CD_NT_MOV
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.PIS_NF
		,V_EST_NF_SAI_IMPOSTOS_PIS_COFINS.COFINS_NF
		,V_EST_NF_SAI_CAB.STS_NF 
		,V_EST_NF_SAI_CAB.VLR_ICMS_SUBS_CAB
