CREATE TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA](
	[CD_GRUPO_LISTA] [int] NOT NULL,
	[DS_GRUPO_LISTA] [varchar](50) NOT NULL,
	[CD_USU] [int] NOT NULL,
	[DT_CAD] [datetime] NOT NULL,
 CONSTRAINT [PK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] PRIMARY KEY CLUSTERED 
(
	[CD_GRUPO_LISTA] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [IX_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] UNIQUE NONCLUSTERED 
(
	[DS_GRUPO_LISTA] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
GO

CREATE TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD](
	[CD_GRUPO_LISTA] [int] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_PROD] [int] NOT NULL,
	[VLR_CUSTO_GRUPO_LISTA] [money] NOT NULL,
 CONSTRAINT [PK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] PRIMARY KEY CLUSTERED 
(
	[CD_GRUPO_LISTA] ASC,
	[CD_EMP] ASC,
	[CD_PROD] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
GO

CREATE TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL](
	[CD_GRUPO_LISTA] [int] NOT NULL,
	[CD_EMP] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
 CONSTRAINT [PK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] PRIMARY KEY CLUSTERED 
(
	[CD_GRUPO_LISTA] ASC,
	[CD_EMP] ASC,
	[CD_FILIAL] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [IX_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] UNIQUE NONCLUSTERED 
(
	[CD_EMP] ASC,
	[CD_FILIAL] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_CD_GRUPO_LISTA]  DEFAULT ((0)) FOR [CD_GRUPO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_DS_GRUPO_LISTA]  DEFAULT ('') FOR [DS_GRUPO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_CD_USU]  DEFAULT ((0)) FOR [CD_USU]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_EST_PROD] FOREIGN KEY([CD_EMP], [CD_PROD])
REFERENCES [dbo].[EST_PROD] ([CD_EMP], [CD_PROD])
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] CHECK CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_EST_PROD]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] FOREIGN KEY([CD_GRUPO_LISTA])
REFERENCES [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] ([CD_GRUPO_LISTA])
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] CHECK CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_CD_GRUPO_LISTA]  DEFAULT ((0)) FOR [CD_GRUPO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_CD_PROD]  DEFAULT ((0)) FOR [CD_PROD]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_EST_PROD_VLR_CUSTO_GRUPO_LISTA]  DEFAULT ((0)) FOR [VLR_CUSTO_GRUPO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] FOREIGN KEY([CD_GRUPO_LISTA])
REFERENCES [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA] ([CD_GRUPO_LISTA])
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_PRC_FILIAL] FOREIGN KEY([CD_EMP], [CD_FILIAL])
REFERENCES [dbo].[PRC_FILIAL] ([CD_EMP], [CD_FILIAL])
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_PRC_FILIAL]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_CD_GRUPO_LISTA]  DEFAULT ((0)) FOR [CD_GRUPO_LISTA]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]
GO

ALTER TABLE [dbo].[EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PROD_PRECIFICACAO_GRUPO_PRECO_LISTA_PRC_FILIAL_CD_FILIAL]  DEFAULT ((0)) FOR [CD_FILIAL]
GO

