IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'VS_PDV_RC' ) )
BEGIN
    ALTER TABLE PDV_VD ADD VS_PDV_RC VARCHAR(50) NULL;
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_CUPOM_NAO_FISCAL') AND NAME LIKE 'CONT_CUPOM_FISC' ) )
BEGIN
    ALTER TABLE PDV_CUPOM_NAO_FISCAL ADD CONT_CUPOM_FISC INTEGER DEFAULT 0;
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'CONT_CUPOM_FISC' ) )
BEGIN
    ALTER TABLE PDV_VD ADD CONT_CUPOM_FISC INTEGER DEFAULT 0
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'VS_PDV_RC' ) )
BEGIN
    ALTER TABLE PDV_VD ADD VS_PDV_RC VARCHAR(50) NULL
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_CUPOM_NAO_FISCAL') AND NAME LIKE 'CONT_CUPOM_FISC' ) )
BEGIN
    ALTER TABLE PDV_CUPOM_NAO_FISCAL ADD CONT_CUPOM_FISC INTEGER DEFAULT 0
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'CONT_CUPOM_FISC' ) )
BEGIN
    ALTER TABLE PDV_VD ADD CONT_CUPOM_FISC INTEGER DEFAULT 0
END

GO

IF ((SELECT MAX_LENGTH FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_LEITURA_Z_VERSUS_CONSOLIDADO') AND NAME LIKE 'HIST_CPL' ) < 500)
 BEGIN
    ALTER TABLE PDV_VD_LEITURA_Z_VERSUS_CONSOLIDADO ALTER COLUMN HIST_CPL VARCHAR(500)
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'PERC_IBPT' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD ADD PERC_IBPT MONEY NULL
    ALTER TABLE DBO.PDV_VD ADD CONSTRAINT DF_PDV_VD_PERC_IBPT DEFAULT 0 FOR PERC_IBPT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'VALOR_IBPT' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD ADD VALOR_IBPT MONEY NULL
    ALTER TABLE DBO.PDV_VD ADD CONSTRAINT DF_PDV_VD_VALOR_IBPT DEFAULT 0 FOR VALOR_IBPT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_IT') AND NAME LIKE 'VALOR_IBPT' ) )
BEGIN
   	ALTER TABLE DBO.PDV_VD_IT ADD VALOR_IBPT MONEY NULL
	ALTER TABLE DBO.PDV_VD_IT ADD CONSTRAINT DF_PDV_VD_IT_VALOR_IBPT DEFAULT 0 FOR VALOR_IBPT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_IT') AND NAME LIKE 'VALOR_IBPT' ) )
BEGIN
   	ALTER TABLE DBO.PDV_VD_IT ADD PERC_IBPT MONEY NULL
	ALTER TABLE DBO.PDV_VD_IT ADD CONSTRAINT DF_PDV_VD_IT_PERC_IBPT DEFAULT 0 FOR PERC_IBPT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_IT') AND NAME LIKE 'TIPO_IMPOSTO' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD_IT ADD TIPO_IMPOSTO INT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'CD_MT_CANCEL' ) )
BEGIN
    ALTER TABLE PDV_VD ADD CD_MT_CANCEL INT
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'CD_CLI_PBM' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD ADD CD_CLI_PBM INT NULL
    ALTER TABLE DBO.PDV_VD ADD CONSTRAINT DF_PDV_VD_CD_CLI_PBM DEFAULT 0 FOR CD_CLI_PBM
END

GO

IF NOT EXISTS (SELECT 1 FROM SYS.INDEXES WHERE NAME = 'IX_PDV_CUPOM_NAO_FISCAL_NR_CUPOM')
BEGIN
	CREATE INDEX IX_PDV_CUPOM_NAO_FISCAL_NR_CUPOM ON PDV_CUPOM_NAO_FISCAL(CD_EMP,CD_FILIAL,CD_CX,DT_CUPOM,NR_COO) INCLUDE (CD_CTR)
END

GO

IF NOT EXISTS (SELECT 1 FROM SYS.INDEXES WHERE NAME = 'IX_PDV_VD_NR_CUPOM')
BEGIN
	CREATE INDEX IX_PDV_VD_NR_CUPOM ON PDV_VD(CD_EMP,CD_FILIAL,CD_CX,DT_VD,NR_ECF)
END

GO

IF NOT EXISTS (SELECT 1 FROM SYS.INDEXES WHERE NAME = 'IX_PDV_VD_IT_VD_PBM')
BEGIN
	CREATE INDEX IX_PDV_VD_IT_VD_PBM ON PDV_VD_IT_VD_PBM(CD_CLI_PBM)
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_TEF') AND NAME LIKE 'TEF_GATEWAY' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD_TEF ADD TEF_GATEWAY VARCHAR(5) NULL
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD_TEF') AND NAME LIKE 'MODALIDADE' ) )
BEGIN
    ALTER TABLE DBO.PDV_VD_TEF ADD MODALIDADE VARCHAR(7) NULL
END

GO

IF  ( NOT EXISTS ( SELECT OBJECT_ID FROM SYS.COLUMNS WHERE OBJECT_ID = OBJECT_ID('PDV_VD') AND NAME LIKE 'FLAG_NFCE' ) )
BEGIN
    ALTER TABLE PDV_VD ADD FLAG_NFCE BIT NULL
END