IF  NOT EXISTS (SELECT * FROM sys.objects 
					WHERE object_id = OBJECT_ID(N'[dbo].[EST_PROD_AGENDA_COMPRA]') 
					AND type in (N'U')) 

BEGIN
	/****** Object:  Table [dbo].[EST_PROD_AGENDA_COMPRA]    Script Date: 31/05/2016 15:53:54 ******/
	SET ANSI_NULLS ON
	SET QUOTED_IDENTIFIER ON
	SET ANSI_PADDING ON

	CREATE TABLE [dbo].[EST_PROD_AGENDA_COMPRA](
		[CD_EMP]	[int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_CD_EMP]  DEFAULT ((0)),
		[CD_CTR_AGENDA] [int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_CD_CTR_AGENDA]  DEFAULT ((0)),
		[DS_AGENDAMENTO] [varchar](50) NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_DS_AGENDAMENTO]  DEFAULT (''),
	
		[FREQ_REV] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_FREQ_REV]  DEFAULT ((0)),
		[LEAD_TIME] [int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_LEAD_TIME]  DEFAULT ((0)),
		[TIPO_FRETE] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_TIPO_FRETE]  DEFAULT ((0)),
		[COMPRA_EMBALADO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_COMPRA_EMBALADO]  DEFAULT ((0)),
		[COMPRA_MULTIPLO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_COMPRA_MULTIPLO]  DEFAULT ((0)),
	
		[PERC_DESC_COMERCIAL] [money] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_PERC_DESC_COMERCIAL]  DEFAULT ((0)),
		[PERC_DESC_FINANCEIRO] [money] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_PERC_DESC_FINANCEIRO]  DEFAULT ((0)),
	
		[PRZ_PGTO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_PRZ_PGTO]  DEFAULT ((0)),
		[SEGUNDA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_SEGUNDA]  DEFAULT ((0)),
		[TERCA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_TERCA]  DEFAULT ((0)),
		[QUARTA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_QUARTA]  DEFAULT ((0)),
		[QUINTA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_QUINTA]  DEFAULT ((0)),
		[SEXTA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_SEXTA]  DEFAULT ((0)),
		[SABADO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_SABADO]  DEFAULT ((0)),
		[DOMINGO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_DOMINGO]  DEFAULT ((0)),
		[PARAM_EST] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_PARAM_EST]  DEFAULT ((0)),
		[DT_AGENDAMENTO_DEFAULT] [datetime] NULL,
		[INDICADOR_SUPRIMENTO] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_INDICADOR_SUPRIMENTO]  DEFAULT ((0)),
		[TIPO_COMPRA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_TIPO_COMPRA]  DEFAULT ((0)),	
		[QT_DIAS_ACRES_AGENDA] [int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_QT_DIAS_ACRES_AGENDA]  DEFAULT ((0)),
		[DT_VALID_ACRES_AGENDA] [datetime] NULL,
		[FLAG_GERAR_AGENDA] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_FLAG_GERAR_AGENDA]  DEFAULT ((0)),
		[FLAG_EXPORTA_NEOGRID] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_FLAG_EXPORTA_NEOGRID]  DEFAULT ((0)),
		[FLAG_LST_PRECO] [tinyint] NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_FLAG_LST_PRECO]  DEFAULT ((0)),
		[FLAG_GRUPO_POSSUI_PRODUTOS] [tinyint] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_FLAG_GRUPO_PRODUTOS]  DEFAULT ((0)), 
		[STS_AGENDA] [tinyint] NULL DEFAULT ((0)), 
		[CD_COMPRADOR] [int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_CD_COMPRADOR]  DEFAULT ((0)),
		[CD_USU] [int] NOT NULL CONSTRAINT [DF_EST_PROD_AGENDA_COMPRA_CD_USU]  DEFAULT ((0)),
		[DT_CAD] [datetime] NULL,
		[DT_ULT_ALT] [datetime] NULL,
		
	CONSTRAINT [PK_EST_PROD_AGENDA_COMPRA] PRIMARY KEY CLUSTERED 
	(	[CD_CTR_AGENDA] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, FILLFACTOR = 90) ON [PRIMARY]
	) ON [PRIMARY]
	SET ANSI_PADDING OFF
	
	
	ALTER TABLE [dbo].[EST_PROD_AGENDA_COMPRA]  WITH CHECK ADD  CONSTRAINT [FK_EST_PROD_AGENDA_COMPRA_EST_COMPRADOR] FOREIGN KEY([CD_EMP],[CD_COMPRADOR])
	REFERENCES [dbo].[EST_COMPRADOR] ([CD_EMP],[CD_COMPRADOR])
	ALTER TABLE [dbo].[EST_PROD_AGENDA_COMPRA] CHECK CONSTRAINT [FK_EST_PROD_AGENDA_COMPRA_EST_COMPRADOR]

END
--select * from [EST_PROD_AGENDA_COMPRA]