IF OBJECT_ID('EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL') IS NULL 
begin
CREATE TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL](
	[CD_EMP] [int] NOT NULL,
	[CD_FILIAL] [int] NOT NULL,
	[CD_PERFIL_DEMOGRAFICO] [int] NOT NULL,
	[CD_PERFIL_TAMANHO] [int] NOT NULL,
	[CD_PERFIL_FATURAMENTO] [int] NOT NULL,
	[CD_USU] [int] NOT NULL,
	[DT_CAD] [datetime] NOT NULL,
 CONSTRAINT [PK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] PRIMARY KEY CLUSTERED 
(
	[CD_EMP] ASC,
	[CD_FILIAL] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]


ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_EMP]  DEFAULT ((0)) FOR [CD_EMP]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_FILIAL]  DEFAULT ((0)) FOR [CD_FILIAL]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_PERFIL_DEMOGRAFICO]  DEFAULT ((0)) FOR [CD_PERFIL_DEMOGRAFICO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_PERFIL_TAMANHO]  DEFAULT ((0)) FOR [CD_PERFIL_TAMANHO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_PERFIL_FATURAMENTO]  DEFAULT ((0)) FOR [CD_PERFIL_FATURAMENTO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_CD_USU]  DEFAULT ((0)) FOR [CD_USU]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] ADD  CONSTRAINT [DF_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_DT_CAD]  DEFAULT (getdate()) FOR [DT_CAD]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_DEMOGRAFICO] FOREIGN KEY([CD_PERFIL_DEMOGRAFICO])
REFERENCES [dbo].[EST_PARAM_COMPRAS_PERFIL_DEMOGRAFICO] ([CD_PERFIL_DEMOGRAFICO])

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_DEMOGRAFICO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_FATURAMENTO] FOREIGN KEY([CD_PERFIL_FATURAMENTO])
REFERENCES [dbo].[EST_PARAM_COMPRAS_PERFIL_FATURAMENTO] ([CD_PERFIL_FATURAMENTO])

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_FATURAMENTO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_TAMANHO] FOREIGN KEY([CD_PERFIL_TAMANHO])
REFERENCES [dbo].[EST_PARAM_COMPRAS_PERFIL_TAMANHO] ([CD_PERFIL_TAMANHO])

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_EST_PARAM_COMPRAS_PERFIL_TAMANHO]

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL]  WITH CHECK ADD  CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_PRC_FILIAL] FOREIGN KEY([CD_EMP], [CD_FILIAL])
REFERENCES [dbo].[PRC_FILIAL] ([CD_EMP], [CD_FILIAL])

ALTER TABLE [dbo].[EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL] CHECK CONSTRAINT [FK_EST_PARAM_COMPRAS_PERFIL_PRC_FILIAL_PRC_FILIAL]
End