IF EXISTS (SELECT * FROM SYS.TRIGGERS WHERE NAME = 'TRG_EST_PED_VD_INCLUI_PENDENCIA_ENVIO')
BEGIN
	DROP TRIGGER TRG_EST_PED_VD_INCLUI_PENDENCIA_ENVIO
END

GO
GO
--ESSA TRIGGER INCLUI PENDNCIA PARA ENVIO DAS INFORMAES PARA SOFTWARES DE TERCEIROS
--ESSA PENDENCIA SER GRAVADA SE E SOMENTE SE O CAMPO FLAG_GRAVA_PENDENCIA DO CABEALHO DO PEDIDO FOR IGUAL A 1
CREATE TRIGGER [dbo].[TRG_EST_PED_VD_INCLUI_PENDENCIA_ENVIO] ON [dbo].[EST_PED_VD] FOR INSERT AS
BEGIN

	INSERT INTO
		EST_PED_VD_ENVIO_PENDENTE
	SELECT
		CD_EMP,
		CD_FILIAL,
		CD_PED,
		1 AS STATUS
	FROM
		INSERTED I
	WHERE
		I.FLAG_GRAVA_PENDENCIA = 1
		AND NOT EXISTS (
			SELECT 
				* 
			FROM 
				EST_PED_VD_ENVIO_PENDENTE 
			WHERE 
				CD_EMP = I.CD_EMP 
				AND CD_FILIAL = I.CD_FILIAL
				AND CD_PED = I.CD_PED)
END