SET ANSI_NULLS ON


SET QUOTED_IDENTIFIER ON


IF NOT EXISTS(
	SELECT 
		1
	FROM 
		 sys.tables 
	WHERE 
		NAME = 'EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL' )
BEGIN

	CREATE TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL](
		[CD_CTR] [int] IDENTITY(1,1) NOT NULL,
		[TIPO_ATIVIDADE] [int] NOT NULL,
		[ANEXO] [int] NOT NULL,
		[RECEITA_BRUTA_12_MESES_INI] [money] NULL,
		[RECEITA_BRUTA_12_MESES_FIM] [money] NULL,
		[ALIQUOTA] [float] NULL,
		[IRPJ] [float] NULL,
		[CSLL] [float] NULL,
		[COFINS] [float] NULL,
		[PIS_PASEP] [float] NULL,
		[CPP] [float] NULL,
		[ICMS] [float] NULL,
		[IPI] [float] NULL,
		[ISS] [float] NULL
	) ON [PRIMARY]


	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_TIPO_ATIVIDADE]  DEFAULT ((0)) FOR [TIPO_ATIVIDADE]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_ANEXO]  DEFAULT ((0)) FOR [ANEXO]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_RECEITA_BRUTA_12_MESES_INI]  DEFAULT ((0)) FOR [RECEITA_BRUTA_12_MESES_INI]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_RECEITA_BRUTA_12_MESES_FIM]  DEFAULT ((0)) FOR [RECEITA_BRUTA_12_MESES_FIM]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_ALIQUOTA]  DEFAULT ((0)) FOR [ALIQUOTA]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_IRPJ]  DEFAULT ((0)) FOR [IRPJ]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_CSLL]  DEFAULT ((0)) FOR [CSLL]

	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_COFINS]  DEFAULT ((0)) FOR [COFINS]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_PIS_PASEP]  DEFAULT ((0)) FOR [PIS_PASEP]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_CPP]  DEFAULT ((0)) FOR [CPP]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_ICMS]  DEFAULT ((0)) FOR [ICMS]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_IPI]  DEFAULT ((0)) FOR [IPI]
	
	ALTER TABLE [dbo].[EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL] ADD  CONSTRAINT [DF_EST_TRIB_ALIQ_ICMS_SIMPLES_NACIONAL_ISS]  DEFAULT ((0)) FOR [ISS]
	
END




