IF OBJECT_ID('EST_NFE_INU_VALIDADA') IS NULL
BEGIN

	SET ANSI_NULLS ON

	SET QUOTED_IDENTIFIER ON

	CREATE TABLE [dbo].[EST_NFE_INU_VALIDADA](
		[CD_INU] [int] NOT NULL,
		[NR_AUTORIZADOR] [varchar](50) NOT NULL,
		[NR_PROTOCOLO] [varchar](50) NOT NULL,
		[VS_PROTOCOLO] [varchar](10) NOT NULL,
		[VS_APLIC] [varchar](30) NOT NULL,
		[DG_VALIDADOR] [varchar](60) NOT NULL,
		[TP_AMB] [int] NOT NULL,
		[STS_IMP] [int] NOT NULL,
		[DT_RECBTO] [datetime] NULL,
		[NSU_SEFAZ] [int] NULL,
	 CONSTRAINT [PK_EST_NFE_INU_VALIDADA] PRIMARY KEY CLUSTERED 
	(
		[CD_INU] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
	) ON [PRIMARY]

	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_CD_INU]  DEFAULT ((0)) FOR [CD_INU]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_NR_AUTORIZADOR]  DEFAULT ('') FOR [NR_AUTORIZADOR]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_NR_PROTOCOLO]  DEFAULT ('') FOR [NR_PROTOCOLO]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_VS_PROTOCOLO]  DEFAULT ('') FOR [VS_PROTOCOLO]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_VS_APLIC]  DEFAULT ('') FOR [VS_APLIC]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_DG_VALIDADOR]  DEFAULT ('') FOR [DG_VALIDADOR]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_TP_AMB]  DEFAULT ((0)) FOR [TP_AMB]
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] ADD  CONSTRAINT [DF_EST_NFE_INU_VALIDADA_STS_IMP]  DEFAULT ((0)) FOR [STS_IMP]

END

IF NOT EXISTS (SELECT * FROM SYS.foreign_keys WHERE NAME = 'FK_EST_NFE_INU_VALIDADA_EST_NF_NFE_INU')
BEGIN
	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA]  WITH CHECK ADD  CONSTRAINT [FK_EST_NFE_INU_VALIDADA_EST_NF_NFE_INU] FOREIGN KEY([CD_INU])
	REFERENCES [dbo].[EST_NF_NFE_INU] ([CD_INU])

	ALTER TABLE [dbo].[EST_NFE_INU_VALIDADA] CHECK CONSTRAINT [FK_EST_NFE_INU_VALIDADA_EST_NF_NFE_INU]
END

